package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.RmsCapacityMapper;
import com.steerinfo.dil.model.RmsCapacity;
import com.steerinfo.dil.service.IRmsCapacityService;
import com.steerinfo.dil.util.DataChange;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author:ZhouZhou
 * @CreateTime:2021/11/9 14:21
 * @Version:V1.0
 */
@Service(value = "rmsCapacityService")
public class RmsCapacityServiceImpl implements IRmsCapacityService {
    @Autowired
    RmsCapacityMapper rmsCapacityMapper;

    /*
    * 获取运力信息
    * */
    @Override
    public List<Map<String, Object>> getCapacityList(Map<String, Object> mapVal) {
        return rmsCapacityMapper.getCapacityList(mapVal);
    }

    /*
    * 增加运力信息
    * */
    @Override
    public int insertCapacity(Map<String,Object> mapValue) {
        BigDecimal carrierId= DataChange.dataToBigDecimal(mapValue.get("carrierIds"));
        BigDecimal capacityTypeId =DataChange.dataToBigDecimal(mapValue.get("capacityTypeId")) ;
        String number=(String) mapValue.get("capacityNumber");
        String capacityCorlor=(String) mapValue.get("capacityCorlor");
        String  capacityOwneris=(String)mapValue.get("capacityOwneris");
        String  capacityVip=(String)mapValue.get("capacityVip");
        String  capacityBlacklist=(String)mapValue.get("capacityBlacklist");
        int i=0;
        //返回没有逻辑删除，且存在该车牌号的数量
        int isrmsCapacitie = rmsCapacityMapper.selectBycapacityNumber(number);
        RmsCapacity rmsCapacity=new RmsCapacity();
        if(isrmsCapacitie==0){
            rmsCapacity.setCarrierId(carrierId);
            rmsCapacity.setCapacityTypeId(capacityTypeId);
            rmsCapacity.setCapacityNumber(number);
            rmsCapacity.setCapacityCorlor(capacityCorlor);
            rmsCapacity.setCapacityOwneris(capacityOwneris);
            rmsCapacity.setCapacityVip(capacityVip);
            rmsCapacity.setCapacityBlacklist(capacityBlacklist);
            rmsCapacity.setCapacityStatus(new BigDecimal(0));
            rmsCapacity.setDeleted(new BigDecimal(0));
            rmsCapacity.setInsertTime(new Date());
            rmsCapacity.setInsertUsername("admin");
            rmsCapacity.setCapacityId(rmsCapacityMapper.selectCapacityId());
            i+= rmsCapacityMapper.insertSelective(rmsCapacity);
        }else {
            return -1;
        }
        return i;
    }

    /*
    * 修改运力信息
    * */
    @Override
    public int updateCapacity(RmsCapacity rmsCapacity) {
        rmsCapacity.setUpdateTime(new Date());
        rmsCapacity.setUpdateUsername("admin");
        return rmsCapacityMapper.updateByPrimaryKeySelective(rmsCapacity);
    }

    /*
    * 删除运力信息
    * */
    @Override
    public int deleteCapacity(BigDecimal id) {
        RmsCapacity rmsCapacity = rmsCapacityMapper.selectByPrimaryKey(id);
       rmsCapacity.setDeleted(new BigDecimal(1));
        return rmsCapacityMapper.updateByPrimaryKeySelective(rmsCapacity);

    }

    /**
     * 根据id获取运力信息
     * @param id
     * @return
     */
    @Override
    public List<Map<String, Object>> getCapacityById(BigDecimal id) {
        return rmsCapacityMapper.getCapacityById(id);
    }

    /*
    * 获取下拉框
    * */
    @Override
    public  List<Map<String,Object>> getCapacityTypeId() {
        return rmsCapacityMapper.getCapacityTypeId();
    }

    @Override
    public List<Map<String, Object>> getCarrierId() {
        return rmsCapacityMapper.getCarrierId();
    }
}
